/**
 * HTAʂJAݒ肵lJSON`ŕԂ܂
 */
function openDialog(name, args) {
    var charCode = settings['charCode'];
    var dialogDir = settings['dialogDir'];

    // A[g\܂
    var popup = function (message, title, type, secToWait) {
        var DEFAULT_TITLE = '';
        title = (typeof title === 'undefined') ? DEFAULT_TITLE : title;
        type = (typeof type === 'undefined') ? 0 : type;
        secToWait = (typeof secToWait === 'undefined') ? 0 : secToWait;
        var ws = new ActiveXObject('WScript.Shell');
        ws.Popup(message, secToWait, title, type);
    };

    // ADODB.Streamgăt@Cǂݍ݁A̓eԂ܂
    var getDataByStream = function (filePath, charset) {
        // 萔ݒ
        // StreamTypeEnum Values
        var adTypeBinary = 1;
        var adTypeText = 2;

        // t@C̓ǂݍ
        var stream = new ActiveXObject('ADODB.Stream');
        try {
            stream.Type = adTypeText;
            stream.Charset = charset || '_autodetect_all';
            stream.Open();
            stream.LoadFromFile(filePath);
            return stream.ReadText();
        }
        catch (e) {
            //popup(e.message + '\n' + filePath);
            return null;
        }
        finally {
            if (stream) {
                stream.Close();
            }
            stream = null;
        }
    };

    // FileSystemObjectgăt@Cǂݍ(shift_jis)A̓eԂ܂
    var getDataByFSO = function (filePath) {
        //---- t@C쏀
        var fso = new ActiveXObject('Scripting.FileSystemObject');
        var iomode = 1; // 1:ǂݍ, 2:o, 8:ǉ
        var fileSize, openData;

        // t@C̓ǂݍ
        try {
            fileSize = fso.GetFile(filePath).Size;
            if (fileSize) {
                openData = fso.OpenTextFile(filePath, iomode);
                return openData.ReadAll();
            }
            return null;
        }
        catch(e) {
            //popup(e.message + '\n' + filePath);
            return null;
        }
        finally {
            if (openData) {
                openData.Close();
            }
            // IuWFNgj
            openData = null;
            fso = null;
        }
    };

    // R[hɂēǂݍޏ𕪊򂵂܂
    // shift_jist@CScripting.FileSystemObjectgēǂݍޕ
    var readTextData = function (filePath, charset) {
        if (charset && charset === 'shift_jis') {
            return getDataByFSO(filePath);
        }
        else {
            return getDataByStream(filePath, charset);
        }
    };

    // w肳ꂽt@CXg̓eAĕԂ܂
    var getFileText = function (dirPath, initList) {
        var fileName;
        var readFilePath;
        var text = '';
        for (var i = 0, lenInitList = initList.length; i < lenInitList; i++) {
            fileName = initList[i];
            readFilePath = dirPath + '\\' + fileName;
            text += readTextData(readFilePath, charCode) + '\r\n';
        }
        return text;
    };

    // w̃t@CQǂݍ݁AusA̓eԂ܂
    // @param args u"": "u"v̑gƂȂAzz
    var getText = function (dialog, type, args) {
        var text = getFileText(dialogDir, dialog[type]);
        if (args) {
            var r_word;
            for (var word in args) {
                r_word = new RegExp(word, 'g');
                text = text.replace(r_word, args[word]);
            }
        }
        return text;
    };

    // whtmlt@Cǂݍ݁Abody̗vf𔲂ousA̓eԂ܂
    // @param args u"": "u"v̑gƂȂAzz
    var getHtml = function (dialog, args) {
        var html = getFileText(dialogDir, [name]);
        var r_bodyValue = new RegExp('<body>([\\s\\S]*)</body>');
        var body = '';
        html.replace(r_bodyValue, function (match, value) {
            body = value;
        });
        var r_word;
        for (var word in args) {
            r_word = new RegExp(word, 'g');
            body = body.replace(r_word, args[word]);
        }
        return body;
    };

    // Azz܂
    var merge = function () {
        var args = Array.prototype.slice.call(arguments);
        var newObj = new Object();
        var arg, key;
        for (var i = 0, lenArgs = args.length; i < lenArgs; i++) {
            arg = args[i];
            for (key in arg) {
                if (arg.hasOwnProperty) {
                    newObj[key] = arg[key];
                }
            }
        }
        return newObj;
    };

    // whtml/css/jst@Cǂݍ݁Äʒuɖߍhtaɓn܂
    // @param args u"": "u"v̑gƂȂAzz
    var getHtaData = function (dialog, args) {
        var ws = new ActiveXObject('WScript.Shell');
        var currentDir = {'%currentDir%': ws.CurrentDirectory.replace(/\\/g, '/') + '/' + dialogDir};

        args = args || new Object();
        // style
        var argsStyle = ('style' in args) ? merge(currentDir, args['style']) : currentDir;
        // js
        var argsScript;
        // ʃTCYݒ̈ƌ
        var dialogWindow = dialog['window'];
        var windowSize = new Object();
        for (var direction in dialogWindow) {
            windowSize['%' + direction + '%'] = dialogWindow[direction];
        }
        argsScript = ('script' in args) ? merge(windowSize, currentDir, args['script']) : merge(windowSize, currentDir);
        // html
        var argsHtml = ('html' in args) ? args['html'] : currentDir;

        // htaʂ̕\
        var oExec = new ActiveXObject('WScript.Shell').Exec('MSHTA.EXE "javascript:new ActiveXObject(\'Scripting.FileSystemObject\').GetStandardStream(0).ReadAll()"');
        title = ('title' in dialog) ? dialog['title'] : '';
        var style = getText(dialog, 'style', argsStyle);
        var script = getText(dialog, 'script', argsScript);
        var html = getHtml(dialog, argsHtml);
        var windowValue = '' +
            '<?xml version="1.0" encoding="shift_jis"?>' +
            '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">' +
            '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">' +
            '<head>' +
            '  <meta http-equiv="Content-Type" content="text/html; charset=shift_jis" />' +
            '  <meta http-equiv="Content-Style-Type" content="text/css" />' +
            '  <meta http-equiv="Content-Script-Type" content="text/javascript" />' +
            '  <title>' + title + '</title>' +
            '  <style type="text/css">' +
            '    ' + style +
            '  </style>' +
            '  <script type="text/javascript">' +
            '    ' + script +
            '  </script>' +
            '  <hta:application showintaskbar="no" border="dialog" borderstyle="raised" contextmenu="no" innerborder="no" maximizebutton="no" minimizebutton="no" scrollflat="yes" scroll="no" />' +
            '</head>' +
            '<body>' +
            '  ' + html +
            '</body>' +
            '</html>';
        oExec.StdIn.WriteLine(windowValue);
        oExec.StdIn.Close();
        return oExec.StdOut.ReadAll();
    };

    return getHtaData(dialogs[name], args);
}
